// Code generated by counterfeiter. DO NOT EDIT.
package signerfakes

import (
	"context"
	"sync"

	"gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/signer/internal/service/signer"
)

type FakeVault struct {
	KeyStub        func(context.Context, string, string) (*signer.VaultKey, error)
	keyMutex       sync.RWMutex
	keyArgsForCall []struct {
		arg1 context.Context
		arg2 string
		arg3 string
	}
	keyReturns struct {
		result1 *signer.VaultKey
		result2 error
	}
	keyReturnsOnCall map[int]struct {
		result1 *signer.VaultKey
		result2 error
	}
	KeysStub        func(context.Context, string) ([]*signer.VaultKey, error)
	keysMutex       sync.RWMutex
	keysArgsForCall []struct {
		arg1 context.Context
		arg2 string
	}
	keysReturns struct {
		result1 []*signer.VaultKey
		result2 error
	}
	keysReturnsOnCall map[int]struct {
		result1 []*signer.VaultKey
		result2 error
	}
	NamespaceKeysStub        func(context.Context, string) ([]string, error)
	namespaceKeysMutex       sync.RWMutex
	namespaceKeysArgsForCall []struct {
		arg1 context.Context
		arg2 string
	}
	namespaceKeysReturns struct {
		result1 []string
		result2 error
	}
	namespaceKeysReturnsOnCall map[int]struct {
		result1 []string
		result2 error
	}
	NamespacesStub        func(context.Context) ([]string, error)
	namespacesMutex       sync.RWMutex
	namespacesArgsForCall []struct {
		arg1 context.Context
	}
	namespacesReturns struct {
		result1 []string
		result2 error
	}
	namespacesReturnsOnCall map[int]struct {
		result1 []string
		result2 error
	}
	SignStub        func([]byte) ([]byte, error)
	signMutex       sync.RWMutex
	signArgsForCall []struct {
		arg1 []byte
	}
	signReturns struct {
		result1 []byte
		result2 error
	}
	signReturnsOnCall map[int]struct {
		result1 []byte
		result2 error
	}
	WithKeyStub        func(string, string) signer.Vault
	withKeyMutex       sync.RWMutex
	withKeyArgsForCall []struct {
		arg1 string
		arg2 string
	}
	withKeyReturns struct {
		result1 signer.Vault
	}
	withKeyReturnsOnCall map[int]struct {
		result1 signer.Vault
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeVault) Key(arg1 context.Context, arg2 string, arg3 string) (*signer.VaultKey, error) {
	fake.keyMutex.Lock()
	ret, specificReturn := fake.keyReturnsOnCall[len(fake.keyArgsForCall)]
	fake.keyArgsForCall = append(fake.keyArgsForCall, struct {
		arg1 context.Context
		arg2 string
		arg3 string
	}{arg1, arg2, arg3})
	stub := fake.KeyStub
	fakeReturns := fake.keyReturns
	fake.recordInvocation("Key", []interface{}{arg1, arg2, arg3})
	fake.keyMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2, arg3)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeVault) KeyCallCount() int {
	fake.keyMutex.RLock()
	defer fake.keyMutex.RUnlock()
	return len(fake.keyArgsForCall)
}

func (fake *FakeVault) KeyCalls(stub func(context.Context, string, string) (*signer.VaultKey, error)) {
	fake.keyMutex.Lock()
	defer fake.keyMutex.Unlock()
	fake.KeyStub = stub
}

func (fake *FakeVault) KeyArgsForCall(i int) (context.Context, string, string) {
	fake.keyMutex.RLock()
	defer fake.keyMutex.RUnlock()
	argsForCall := fake.keyArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2, argsForCall.arg3
}

func (fake *FakeVault) KeyReturns(result1 *signer.VaultKey, result2 error) {
	fake.keyMutex.Lock()
	defer fake.keyMutex.Unlock()
	fake.KeyStub = nil
	fake.keyReturns = struct {
		result1 *signer.VaultKey
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) KeyReturnsOnCall(i int, result1 *signer.VaultKey, result2 error) {
	fake.keyMutex.Lock()
	defer fake.keyMutex.Unlock()
	fake.KeyStub = nil
	if fake.keyReturnsOnCall == nil {
		fake.keyReturnsOnCall = make(map[int]struct {
			result1 *signer.VaultKey
			result2 error
		})
	}
	fake.keyReturnsOnCall[i] = struct {
		result1 *signer.VaultKey
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) Keys(arg1 context.Context, arg2 string) ([]*signer.VaultKey, error) {
	fake.keysMutex.Lock()
	ret, specificReturn := fake.keysReturnsOnCall[len(fake.keysArgsForCall)]
	fake.keysArgsForCall = append(fake.keysArgsForCall, struct {
		arg1 context.Context
		arg2 string
	}{arg1, arg2})
	stub := fake.KeysStub
	fakeReturns := fake.keysReturns
	fake.recordInvocation("Keys", []interface{}{arg1, arg2})
	fake.keysMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeVault) KeysCallCount() int {
	fake.keysMutex.RLock()
	defer fake.keysMutex.RUnlock()
	return len(fake.keysArgsForCall)
}

func (fake *FakeVault) KeysCalls(stub func(context.Context, string) ([]*signer.VaultKey, error)) {
	fake.keysMutex.Lock()
	defer fake.keysMutex.Unlock()
	fake.KeysStub = stub
}

func (fake *FakeVault) KeysArgsForCall(i int) (context.Context, string) {
	fake.keysMutex.RLock()
	defer fake.keysMutex.RUnlock()
	argsForCall := fake.keysArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeVault) KeysReturns(result1 []*signer.VaultKey, result2 error) {
	fake.keysMutex.Lock()
	defer fake.keysMutex.Unlock()
	fake.KeysStub = nil
	fake.keysReturns = struct {
		result1 []*signer.VaultKey
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) KeysReturnsOnCall(i int, result1 []*signer.VaultKey, result2 error) {
	fake.keysMutex.Lock()
	defer fake.keysMutex.Unlock()
	fake.KeysStub = nil
	if fake.keysReturnsOnCall == nil {
		fake.keysReturnsOnCall = make(map[int]struct {
			result1 []*signer.VaultKey
			result2 error
		})
	}
	fake.keysReturnsOnCall[i] = struct {
		result1 []*signer.VaultKey
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) NamespaceKeys(arg1 context.Context, arg2 string) ([]string, error) {
	fake.namespaceKeysMutex.Lock()
	ret, specificReturn := fake.namespaceKeysReturnsOnCall[len(fake.namespaceKeysArgsForCall)]
	fake.namespaceKeysArgsForCall = append(fake.namespaceKeysArgsForCall, struct {
		arg1 context.Context
		arg2 string
	}{arg1, arg2})
	stub := fake.NamespaceKeysStub
	fakeReturns := fake.namespaceKeysReturns
	fake.recordInvocation("NamespaceKeys", []interface{}{arg1, arg2})
	fake.namespaceKeysMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeVault) NamespaceKeysCallCount() int {
	fake.namespaceKeysMutex.RLock()
	defer fake.namespaceKeysMutex.RUnlock()
	return len(fake.namespaceKeysArgsForCall)
}

func (fake *FakeVault) NamespaceKeysCalls(stub func(context.Context, string) ([]string, error)) {
	fake.namespaceKeysMutex.Lock()
	defer fake.namespaceKeysMutex.Unlock()
	fake.NamespaceKeysStub = stub
}

func (fake *FakeVault) NamespaceKeysArgsForCall(i int) (context.Context, string) {
	fake.namespaceKeysMutex.RLock()
	defer fake.namespaceKeysMutex.RUnlock()
	argsForCall := fake.namespaceKeysArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeVault) NamespaceKeysReturns(result1 []string, result2 error) {
	fake.namespaceKeysMutex.Lock()
	defer fake.namespaceKeysMutex.Unlock()
	fake.NamespaceKeysStub = nil
	fake.namespaceKeysReturns = struct {
		result1 []string
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) NamespaceKeysReturnsOnCall(i int, result1 []string, result2 error) {
	fake.namespaceKeysMutex.Lock()
	defer fake.namespaceKeysMutex.Unlock()
	fake.NamespaceKeysStub = nil
	if fake.namespaceKeysReturnsOnCall == nil {
		fake.namespaceKeysReturnsOnCall = make(map[int]struct {
			result1 []string
			result2 error
		})
	}
	fake.namespaceKeysReturnsOnCall[i] = struct {
		result1 []string
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) Namespaces(arg1 context.Context) ([]string, error) {
	fake.namespacesMutex.Lock()
	ret, specificReturn := fake.namespacesReturnsOnCall[len(fake.namespacesArgsForCall)]
	fake.namespacesArgsForCall = append(fake.namespacesArgsForCall, struct {
		arg1 context.Context
	}{arg1})
	stub := fake.NamespacesStub
	fakeReturns := fake.namespacesReturns
	fake.recordInvocation("Namespaces", []interface{}{arg1})
	fake.namespacesMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeVault) NamespacesCallCount() int {
	fake.namespacesMutex.RLock()
	defer fake.namespacesMutex.RUnlock()
	return len(fake.namespacesArgsForCall)
}

func (fake *FakeVault) NamespacesCalls(stub func(context.Context) ([]string, error)) {
	fake.namespacesMutex.Lock()
	defer fake.namespacesMutex.Unlock()
	fake.NamespacesStub = stub
}

func (fake *FakeVault) NamespacesArgsForCall(i int) context.Context {
	fake.namespacesMutex.RLock()
	defer fake.namespacesMutex.RUnlock()
	argsForCall := fake.namespacesArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeVault) NamespacesReturns(result1 []string, result2 error) {
	fake.namespacesMutex.Lock()
	defer fake.namespacesMutex.Unlock()
	fake.NamespacesStub = nil
	fake.namespacesReturns = struct {
		result1 []string
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) NamespacesReturnsOnCall(i int, result1 []string, result2 error) {
	fake.namespacesMutex.Lock()
	defer fake.namespacesMutex.Unlock()
	fake.NamespacesStub = nil
	if fake.namespacesReturnsOnCall == nil {
		fake.namespacesReturnsOnCall = make(map[int]struct {
			result1 []string
			result2 error
		})
	}
	fake.namespacesReturnsOnCall[i] = struct {
		result1 []string
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) Sign(arg1 []byte) ([]byte, error) {
	var arg1Copy []byte
	if arg1 != nil {
		arg1Copy = make([]byte, len(arg1))
		copy(arg1Copy, arg1)
	}
	fake.signMutex.Lock()
	ret, specificReturn := fake.signReturnsOnCall[len(fake.signArgsForCall)]
	fake.signArgsForCall = append(fake.signArgsForCall, struct {
		arg1 []byte
	}{arg1Copy})
	stub := fake.SignStub
	fakeReturns := fake.signReturns
	fake.recordInvocation("Sign", []interface{}{arg1Copy})
	fake.signMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeVault) SignCallCount() int {
	fake.signMutex.RLock()
	defer fake.signMutex.RUnlock()
	return len(fake.signArgsForCall)
}

func (fake *FakeVault) SignCalls(stub func([]byte) ([]byte, error)) {
	fake.signMutex.Lock()
	defer fake.signMutex.Unlock()
	fake.SignStub = stub
}

func (fake *FakeVault) SignArgsForCall(i int) []byte {
	fake.signMutex.RLock()
	defer fake.signMutex.RUnlock()
	argsForCall := fake.signArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeVault) SignReturns(result1 []byte, result2 error) {
	fake.signMutex.Lock()
	defer fake.signMutex.Unlock()
	fake.SignStub = nil
	fake.signReturns = struct {
		result1 []byte
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) SignReturnsOnCall(i int, result1 []byte, result2 error) {
	fake.signMutex.Lock()
	defer fake.signMutex.Unlock()
	fake.SignStub = nil
	if fake.signReturnsOnCall == nil {
		fake.signReturnsOnCall = make(map[int]struct {
			result1 []byte
			result2 error
		})
	}
	fake.signReturnsOnCall[i] = struct {
		result1 []byte
		result2 error
	}{result1, result2}
}

func (fake *FakeVault) WithKey(arg1 string, arg2 string) signer.Vault {
	fake.withKeyMutex.Lock()
	ret, specificReturn := fake.withKeyReturnsOnCall[len(fake.withKeyArgsForCall)]
	fake.withKeyArgsForCall = append(fake.withKeyArgsForCall, struct {
		arg1 string
		arg2 string
	}{arg1, arg2})
	stub := fake.WithKeyStub
	fakeReturns := fake.withKeyReturns
	fake.recordInvocation("WithKey", []interface{}{arg1, arg2})
	fake.withKeyMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeVault) WithKeyCallCount() int {
	fake.withKeyMutex.RLock()
	defer fake.withKeyMutex.RUnlock()
	return len(fake.withKeyArgsForCall)
}

func (fake *FakeVault) WithKeyCalls(stub func(string, string) signer.Vault) {
	fake.withKeyMutex.Lock()
	defer fake.withKeyMutex.Unlock()
	fake.WithKeyStub = stub
}

func (fake *FakeVault) WithKeyArgsForCall(i int) (string, string) {
	fake.withKeyMutex.RLock()
	defer fake.withKeyMutex.RUnlock()
	argsForCall := fake.withKeyArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeVault) WithKeyReturns(result1 signer.Vault) {
	fake.withKeyMutex.Lock()
	defer fake.withKeyMutex.Unlock()
	fake.WithKeyStub = nil
	fake.withKeyReturns = struct {
		result1 signer.Vault
	}{result1}
}

func (fake *FakeVault) WithKeyReturnsOnCall(i int, result1 signer.Vault) {
	fake.withKeyMutex.Lock()
	defer fake.withKeyMutex.Unlock()
	fake.WithKeyStub = nil
	if fake.withKeyReturnsOnCall == nil {
		fake.withKeyReturnsOnCall = make(map[int]struct {
			result1 signer.Vault
		})
	}
	fake.withKeyReturnsOnCall[i] = struct {
		result1 signer.Vault
	}{result1}
}

func (fake *FakeVault) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.keyMutex.RLock()
	defer fake.keyMutex.RUnlock()
	fake.keysMutex.RLock()
	defer fake.keysMutex.RUnlock()
	fake.namespaceKeysMutex.RLock()
	defer fake.namespaceKeysMutex.RUnlock()
	fake.namespacesMutex.RLock()
	defer fake.namespacesMutex.RUnlock()
	fake.signMutex.RLock()
	defer fake.signMutex.RUnlock()
	fake.withKeyMutex.RLock()
	defer fake.withKeyMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeVault) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ signer.Vault = new(FakeVault)
